# Temporary FT24 control repo

## Initial setup
To install all necessary dependencies, run:
```
rosdep install --from-paths src -y --ignore-src
```

Then build this package via the normal ROS2 build process:
```
colcon build --symlink-install
source install/setup.bash 
```

## Simulation Start
For the Gazebo simulation, run:
```
ros2 launch ft24_control launch_sim.py
```

You can control the car with the keyboard by publishing Twist commands by opening a separate terminal and running:
```
ros2 run teleop_twist_keyboard teleop_twist_keyboard --ros-args -r /cmd_vel:=/ackermann_steering_controller/reference_unstamped
```

## Robot Control
The robot control is implemented in the `ft24_control` package and can be launched with \
`ros2 launch ft24_control launch_robot.py`.\
This launch file brings up the `ros2_control`-based nodes that serve as the interface between the physical robot and the ROS2 software stack.