#ifndef SET_LINK_STATE_SYSTEM_PLUGIN_H
#define SET_LINK_STATE_SYSTEM_PLUGIN_H

#include <gz/sim/System.hh>
#include <gz/sim/EventManager.hh>


using namespace gz::sim;

namespace set_link_state_system_plugin
{
  class SetLinkStateSystemPlugin:
  public gz::sim::System,
  public gz::sim::ISystemConfigure,
  public gz::sim::ISystemUpdate
  {
  public:
    /// \brief Constructor
    SetLinkStateSystemPlugin() = default;

    /// \brief Destructor
    virtual ~SetLinkStateSystemPlugin() = default;

    // Ignition Gazebo System interface
    public: void Configure(const Entity & _entity, const std::shared_ptr<const sdf::Element> & _sdf,
               gz::sim::EntityComponentManager & _ecm, gz::sim::EventManager & _eventManager) override;

    public: void Update(const gz::sim::UpdateInfo &_info,
                gz::sim::EntityComponentManager &_ecm) override;
                       
  };
}

#endif // SET_LINK_STATE_SYSTEM_PLUGIN_H
