#include "../include/SetLinkStatePlugin.hpp"

//! [registerSampleSystem]
#include <gz/plugin/RegisterMore.hh>
#include <gz/sim/components.hh>

using namespace components;

// Include a line in your source file for each interface implemented.
IGNITION_ADD_PLUGIN(
    set_link_state_system_plugin::SetLinkStateSystemPlugin,
    gz::sim::System,
    set_link_state_system_plugin::SetLinkStateSystemPlugin::ISystemConfigure,
    set_link_state_system_plugin::SetLinkStateSystemPlugin::ISystemUpdate
)
//! [registerSampleSystem]
//! [implementSampleSystem]
using namespace set_link_state_system_plugin;

using namespace ignition::gazebo;

// Ignition Gazebo System interface
void SetLinkStateSystemPlugin::Configure(const Entity & _entity, const std::shared_ptr<const sdf::Element> & _sdf,
                                                                                 EntityComponentManager & _ecm, EventManager & _eventManager)
{

    // Get the world entity
    auto worldEntity = _ecm.EntityByComponents(components::Name("world"), components::World());
    if (worldEntity == kNullEntity)
    {
        ignerr << "Failed to find the world entity.\n";
        return;
    }



    ignmsg << "SetLinkStateSystemPlugin configured.\n";
}

void SetLinkStateSystemPlugin::Update(const UpdateInfo & _info, EntityComponentManager & _ecm)
{
    // Get the current simulation time in Fortress

    // TODO: Implement communication with Fortress co-simulation script to get link states, velocities, accelerations, etc.
    //
}

